// DTActivityController.h
// Created by Rob Rix on 2011-04-14
// Copyright 2011 DEVONtechnologies, LLC

#import <Cocoa/Cocoa.h>

@class DTActivityLog;

@interface DTActivityWindow : NSPanel

-(BOOL)byUser;
-(NSSize)preferredSize;
-(IBAction)orderFrontActivityPanel:(id)sender;

@end

#define DTActivityController					DTActivityWindowController
#define DTActivityControllerClassFromString()	NSClassFromString(@"DTActivityWindowController")

@interface DTActivityController : NSWindowController

+(BOOL)isVisible;
+(void)close;
+(instancetype)sharedController;

-(NSArray<DTActivityLog *> *)logs;
-(NSUInteger)count;

-(DTActivityLog *)logForKey:(id)key;
-(void)setLog:(DTActivityLog *)log forKey:(id)key;
-(void)setLog:(DTActivityLog *)log forKey:(id)key showWindow:(BOOL)showWindow;
-(DTActivityLog *)addLogForKey:(id)key title:(NSString *)title showWindow:(BOOL)showWindow; // Creates a new log only if necessary

-(void)removeLogForKey:(id)key;
-(void)removeLogForKey:(id)key orderOut:(BOOL)orderOut;

@end

@protocol DTActivityControllerDelegate // Implemented by application delegate

@optional
-(void)controller:(DTActivityController *)controller didAddLogForKey:(id)key;
-(BOOL)controller:(DTActivityController *)controller showWindowForKey:(id)key;
-(void)controller:(DTActivityController *)controller didRemoveLogForKey:(id)key;
-(BOOL)controller:(DTActivityController *)controller orderOutForKey:(id)key;

@end

@interface DTActivityView : NSView
@end

@interface DTActivityCollectionView : NSCollectionView
@end

@interface DTActivityPane : NSViewController

-(__kindof DTActivityController *)controller;
-(NSCollectionView *)collectionView;
-(NSArray<DTActivityLog *> *)logs;

@end


